
%%
%postup na zjisteni poctu iteraci L pro pevne zvolenou absolutni chybu mezi
%presnym resenim a aproximaci  pro priklad 3 (linearni proces zrodu a
%zaniku
%%
clear
close all
clc
%% pocatecni hodnoty
t=1; % volba t
eps=10^-7; % abs chyba
max_iter=300; % maximalni pocet iteraci

 


%% volba hodnot r,m,n,t
r=1;  % velikost populace v case t
m=2; % pocatecni velikost populace v case t=0
n=20; % n-ty aproximant , pri kombinaci r=0, m=0, n=0 dojde k zacykleni

%% zadane hodnoty intenzit
mu=0.4;
lambda=0.2;
lambda_0=0.0000000001; % podminka: lambda_0 musi byt vetsi nez 0
 

%% tvorba posloupnosti pro lambda(r)
lambda_r=zeros(1,n+m+r);
for i=1:n+m+r
    lambda_r(i)=lambda*i;
end

%% tvorba posloupnosti pro mu(r)
mu_r=zeros(1,n+m+r);
for i=1:n+m+r
    mu_r(i)=mu*i;
end
%%
%% presne reseni

AA(t)=(1-exp((lambda-mu)*t))/(mu-lambda*exp((lambda-mu)*t));
if r==0
    p_r_presne(t)=(mu*AA(t))^m;
else
p_r_presne(t)=(1-lambda*AA(t))*(1-mu*AA(t))*(lambda*AA(t))^(r-1);
end

roots_search=2; % volba metody na vypocet korenu; 1 - pomoci matice a vl. cisel; 2- QD - algoritmus
[h,p_r]=christ_num(r,m,n,lambda_0,lambda_r,mu_r,roots_search,1);
 k=1;
 while  abs((p_r(t)-p_r_presne(t))')>eps && k<max_iter  % pokracuj dokud neni stanovena chyba nebo do max. iterace 
     
 k=k+1;
 L=k;
%%
[h,p_r]=christ_num(r,m,n,lambda_0,lambda_r,mu_r,roots_search,L); % zavola funkci a vypocte cisla h a priblizny vypocet ppsti funkce p_r(t)

%%
 end
 fprintf('Absolutni chyba=%1.9f, pocatecni iteraci L=%1.0f\n',eps,k)

