
% funkce, ktera vrati koreny jmenovatele B_r,n pomoci QD-algoritmu
% postup nalezneme na strane 62
function [roots,R]=roots_method2(L,K,lambda_0,lambda_r,mu_r) % K=m+n nebo K=r+n
% kde m...pocatecni velikost populace, r... velikost populace v case t

%% Tvorba qd-tabulky
%% vztahy (6.44) a (6.45) na str. 62
q_j=zeros(L,K);
q_j(1,1)=-lambda_0;
for j=2:K  
    q_j(1,j)=-lambda_r(j-1);
end

e_j=zeros(L,K);
for i=1:K-1
    e_j(1,i)=-mu_r(i);
end

%%
for k=1:L-1
    q_j(k+1,1)=e_j(k,1)+q_j(k,1);
    e_j(k+1,1)=(q_j(k,2)/q_j(k+1,1))*e_j(k,1);
    for l=2:K-1
        q_j(k+1,l)=e_j(k,l)-e_j(k+1,l-1)+q_j(k,l);
        e_j(k+1,l)=(q_j(k,l+1)/q_j(k+1,l))*e_j(k,l);
        
    end
    q_j(k+1,K)=e_j(k,K)-e_j(k+1,K-1)+q_j(k,K);
end
roots=sort(q_j(L,:)','descend'); % serazeni korenu
R=length(roots);